local UIUtil = import('/lua/modules/ui/uiutil.lua')
local LayoutHelpers = import('/lua/modules/maui/layouthelpers.lua')
local Grid = import('/lua/modules/maui/grid.lua').Grid

function SetLayout()
    local controls = import('/lua/modules/ui/game/construction.lua').controls
    local mfdControl = import('/lua/modules/ui/game/construction.lua').mfdControl
    local ordersControl = import('/lua/modules/ui/game/construction.lua').ordersControl
    local controlClusterGroup = import('/lua/modules/ui/game/construction.lua').controlClusterGroup
    local queueControl = import('/lua/modules/ui/game/construction.lua').queueControl
    
    controls.constructionGroup.Top:Set(function() return queueControl.Top() - 10 - controls.unitsBGCapMin.Height() end)
    controls.constructionGroup.Bottom:Set(queueControl.Top)
    controls.constructionGroup.Left:Set(ordersControl.Right)
    controls.constructionGroup.Right:Set(controlClusterGroup.Right)
    
    controls.constructionGroup.Mini = function(state)
        controls.constructionGroup:SetHidden(state)
    end

    controls.unitsBGCapMin:SetTexture(UIUtil.SkinnableFile('/game/mini-ui-construct-que-back/back_bmp_l.dds'))
    LayoutHelpers.AtTopIn(controls.unitsBGCapMin, controls.constructionGroup, 1)
    LayoutHelpers.AtLeftIn(controls.unitsBGCapMin, controls.constructionGroup, -2)
    LayoutHelpers.ResetBottom(controls.unitsBGCapMin)
    LayoutHelpers.ResetRight(controls.unitsBGCapMin)    

	
    controls.unitsBGCapMax:SetTexture(UIUtil.SkinnableFile('/game/mini-ui-construct-que-back/back_bmp_r.dds'))
    LayoutHelpers.AtTopIn(controls.unitsBGCapMax, controls.constructionGroup, 1)
    LayoutHelpers.AtRightIn(controls.unitsBGCapMax, controls.constructionGroup, -286)
    LayoutHelpers.ResetLeft(controls.unitsBGCapMax)
    LayoutHelpers.ResetBottom(controls.unitsBGCapMax)

    controls.unitsBGMiddle:SetTexture(UIUtil.SkinnableFile('/game/mini-ui-construct-que-back/back_bmp_m.dds'))
    controls.unitsBGMiddle.Left:Set(controls.unitsBGCapMin.Right)
    controls.unitsBGMiddle.Right:Set(controls.unitsBGCapMax.Left)
    controls.unitsBGMiddle.Top:Set(controls.unitsBGCapMin.Top)
    controls.unitsBGMiddle:SetTiled(true)
    LayoutHelpers.ResetWidth(controls.unitsBGMiddle)
    LayoutHelpers.ResetBottom(controls.unitsBGMiddle)
    controls.unitsBGMiddle.Height:Set(controls.unitsBGMiddle.BitmapHeight)
    
    controls.tech1Tab.checkbox:SetNewTextures(
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_up.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_over.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'))
    LayoutHelpers.AtLeftTopIn(controls.tech1Tab.checkbox, controls.unitsBGCapMin, 0, -32)
    controls.tech1Tab.checkbox.Depth:Set(function() return controls.unitsBGMiddle.Depth() + 100 end)
    controls.tech1Tab.checkbox:Disable()


    LayoutHelpers.AtCenterIn(controls.tech1Tab.icon, controls.tech1Tab.checkbox)
    controls.tech1Tab.icon.Depth:Set(function() return controls.unitsBGMiddle.Depth() + 101 end)
    controls.tech1Tab.icon:DisableHitTest()


    controls.tech2Tab.checkbox:SetNewTextures(
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_up.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_over.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'))
    LayoutHelpers.RightOf(controls.tech2Tab.checkbox, controls.tech1Tab.checkbox, -30)
    controls.tech2Tab.checkbox.Depth:Set(function() return controls.tech1Tab.checkbox.Depth() + 1 end)
    controls.tech2Tab.checkbox:Disable()


    LayoutHelpers.AtCenterIn(controls.tech2Tab.icon, controls.tech2Tab.checkbox)
    controls.tech2Tab.icon.Depth:Set(function() return controls.tech1Tab.checkbox.Depth() + 20 end)
    controls.tech2Tab.icon:DisableHitTest()


    controls.tech3Tab.checkbox:SetNewTextures(
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_up.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_over.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'))
    LayoutHelpers.RightOf(controls.tech3Tab.checkbox, controls.tech2Tab.checkbox, -30)
    controls.tech3Tab.checkbox.Depth:Set(function() return controls.tech2Tab.checkbox.Depth() + 1 end)
    controls.tech3Tab.checkbox:Disable()


    LayoutHelpers.AtCenterIn(controls.tech3Tab.icon, controls.tech3Tab.checkbox)
    controls.tech3Tab.icon.Depth:Set(function() return controls.tech2Tab.checkbox.Depth() + 20 end)
    controls.tech3Tab.icon:DisableHitTest()


    controls.tech4Tab.checkbox:SetNewTextures(
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_up.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_over.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_down.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'),
            UIUtil.SkinnableFile('/game/tech-tabs_btn/tech-tab02_btn_dis.dds'))
    LayoutHelpers.RightOf(controls.tech4Tab.checkbox, controls.tech3Tab.checkbox, -30)
    controls.tech4Tab.checkbox.Depth:Set(function() return controls.tech3Tab.checkbox.Depth() + 1 end)
    controls.tech4Tab.checkbox:Disable()


    LayoutHelpers.AtCenterIn(controls.tech4Tab.icon, controls.tech4Tab.checkbox)
    controls.tech4Tab.icon.Depth:Set(function() return controls.tech1Tab.checkbox.Depth() + 20 end)
    controls.tech4Tab.icon:DisableHitTest()
    
    LayoutHelpers.FillParent(controls.tech2disabledOverGroup, controls.tech2Tab.checkbox) 
    controls.tech2disabledOverGroup.Depth:Set(function() return controls.tech2Tab.checkbox.Depth() + 5 end)
    
    LayoutHelpers.FillParent(controls.tech3disabledOverGroup, controls.tech3Tab.checkbox) 
    controls.tech3disabledOverGroup.Depth:Set(function() return controls.tech3Tab.checkbox.Depth() + 5 end)
    
    LayoutHelpers.FillParent(controls.tech4disabledOverGroup, controls.tech4Tab.checkbox) 
    controls.tech4disabledOverGroup.Depth:Set(function() return controls.tech4Tab.checkbox.Depth() + 5 end)

    
    controls.scrollUnitsBackButton:SetNewTextures(UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_up.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_down.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_over.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_dis.dds'))
    controls.scrollUnitsBackButton.Left:Set(function() return controls.unitsBGMiddle.Left() - 12 end)
    LayoutHelpers.AtVerticalCenterIn( controls.scrollUnitsBackButton, controls.unitsBGMiddle, 1)
    LayoutHelpers.ResetRight(controls.scrollUnitsBackButton)
    controls.scrollUnitsBackButton.Depth:Set(function() return controls.unitsBGCapMin.Depth() + 200 end)
    controls.scrollUnitsBackButton:Disable()

    controls.scrollUnitsFwdButton:SetNewTextures(UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_up.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_down.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_over.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_dis.dds'))
    controls.scrollUnitsFwdButton.Right:Set(function() return controls.unitsBGMiddle.Right() + 12 end)
    LayoutHelpers.ResetLeft(controls.scrollUnitsFwdButton) 
    LayoutHelpers.AtVerticalCenterIn( controls.scrollUnitsFwdButton, controls.unitsBGMiddle, 1)
    controls.scrollUnitsFwdButton.Depth:Set(function() return controls.scrollUnitsBackButton.Depth() + 1 end)
    controls.scrollUnitsFwdButton:Disable()

    controls.enhanceButton.Bottom:Set(function() return controls.scrollUnitsBackButton.Top() + 0 end)
    controls.enhanceButton:SetNewTextures(UIUtil.UIFile('/dialogs/enhance-panel-small_btn/infinite_btn_up.dds'),
        UIUtil.UIFile('/dialogs/enhance-panel-small_btn/infinite_btn_down.dds'),
        UIUtil.UIFile('/dialogs/enhance-panel-small_btn/infinite_btn_over.dds'),
        UIUtil.UIFile('/dialogs/enhance-panel-small_btn/infinite_btn_dis.dds'))
    controls.enhanceButton:SetTexture(UIUtil.UIFile('/dialogs/enhance-panel-small_btn/infinite_btn_up.dds'))
    LayoutHelpers.AtLeftTopIn(controls.enhanceButton, controls.unitsBGCapMin, 15, 10)
    LayoutHelpers.ResetBottom(controls.enhanceButton)
    controls.enhanceButton.Height:Set(controls.enhanceButton.BitmapHeight)
    controls.enhanceButton.Width:Set(controls.enhanceButton.BitmapWidth)

    controls.unitGrid:Destroy()
    controls.unitGrid = Grid(controls.unitsBGMiddle, 48, 48)
    
    controls.unitGrid.Left:Set(function() return controls.unitsBGCapMin.Right() + 4 end)
    controls.unitGrid.Right:Set(function() return controls.unitsBGCapMax.Left() - 4 end)
    controls.unitGrid.Height:Set(function() return 48 end)
    LayoutHelpers.AtVerticalCenterIn(controls.unitGrid, controls.unitsBGMiddle, 2)
    LayoutHelpers.ResetWidth(controls.unitGrid)
end