
local UIUtil = import('/lua/modules/ui/uiutil.lua')
local LayoutHelpers = import('/lua/modules/maui/layouthelpers.lua')
local Grid = import('/lua/modules/maui/grid.lua').Grid

function SetLayout()
    local controls = import('/lua/modules/ui/game/queue.lua').controls
    
    controls.queueGroup.Height:Set(50)
    controls.queueGroup.Bottom:Set(function() return controls.controlClusterGroup.Bottom() + 5 end)
    controls.queueGroup.Left:Set(controls.ordersControl.Right)
    controls.queueGroup.Right:Set(controls.controlClusterGroup.Right)
    
    controls.queueGroup.Mini = function(state)
        controls.queueGroup:SetHidden(state)
    end

    controls.queueBGCapMin:SetTexture(UIUtil.SkinnableFile('/game/mini-ui-construct-que-back/back_bmp_l.dds'))
    LayoutHelpers.AtBottomIn(controls.queueBGCapMin, controls.queueGroup, 3)
    LayoutHelpers.AtLeftIn(controls.queueBGCapMin, controls.queueGroup, -2)
    LayoutHelpers.ResetTop(controls.queueBGCapMin)
    LayoutHelpers.ResetRight(controls.queueBGCapMin)

    controls.queueBGCapMax:SetTexture(UIUtil.SkinnableFile('/game/mini-ui-construct-que-back/back_bmp_r.dds'))
    LayoutHelpers.AtBottomIn(controls.queueBGCapMax, controls.queueGroup, 3)
    LayoutHelpers.AtRightIn(controls.queueBGCapMax, controls.queueGroup, -286)
    LayoutHelpers.ResetTop(controls.queueBGCapMax)
    LayoutHelpers.ResetLeft(controls.queueBGCapMax)

    controls.queueBGMiddle:SetTexture(UIUtil.SkinnableFile('/game/mini-ui-construct-que-back/back_bmp_m.dds'))
    controls.queueBGMiddle.Left:Set(controls.queueBGCapMin.Right)
    controls.queueBGMiddle.Right:Set(controls.queueBGCapMax.Left)
    controls.queueBGMiddle.Top:Set(controls.queueBGCapMin.Top)
    LayoutHelpers.ResetWidth(controls.queueBGMiddle)
    controls.queueBGMiddle.Height:Set(controls.queueBGMiddle.BitmapHeight)
    LayoutHelpers.ResetBottom(controls.queueBGMiddle)
    controls.queueBGMiddle:SetTiled(true)

    controls.queueScrollBG.Depth:Set(function() return controls.queueBGCapMin.Depth() + 50 end)
    controls.queueScrollBG:SetTexture(UIUtil.SkinnableFile('/game/que_bmp/scroll-back_bmp.dds'))
    LayoutHelpers.RelativeTo(controls.queueScrollBG,
        controls.queueBGCapMin,
        UIUtil.SkinnableFile('/game/que_bmp/que_bmp_layout.lua'),
        "scroll-back_bmp",
        "que_bmp_l")


    controls.scrollQueueBackButton:SetNewTextures(UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_up.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_down.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_over.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-left_scr_dis.dds'))
    controls.scrollQueueBackButton.Depth:Set(function() return controls.queueScrollBG.Depth() + 1 end)
    controls.scrollQueueBackButton.Left:Set(function() return controls.queueBGMiddle.Left() - 12 end)
    LayoutHelpers.AtVerticalCenterIn( controls.scrollQueueBackButton, controls.queueBGMiddle, 1)
    
    controls.scrollQueueFwdButton:SetNewTextures(UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_up.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_down.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_over.dds')
        , UIUtil.UIFile('/game/mini-scroll/arrow-right_scr_dis.dds'))
    LayoutHelpers.ResetLeft(controls.scrollQueueFwdButton) 
    controls.scrollQueueFwdButton.Depth:Set(function() return controls.scrollQueueBackButton.Depth() + 1 end)
    controls.scrollQueueFwdButton.Right:Set(function() return controls.queueBGMiddle.Right() + 12 end)
    LayoutHelpers.AtVerticalCenterIn( controls.scrollQueueFwdButton, controls.queueBGMiddle, 1)
        
    LayoutHelpers.AtLeftTopIn(controls.infiniteQueueToggle, controls.queueBGCapMin, 2, 10)
    -- place centered between queue scroll buttons
    controls.infiniteQueueToggle.Width:Set(30)
    
    LayoutHelpers.RightOf(controls.pauseToggle, controls.infiniteQueueToggle, -3)
    controls.pauseToggle.Width:Set(30)

    controls.queueScrollBG:Destroy()

    controls.queueGrid:Destroy()
    controls.queueGrid = Grid(controls.queueBGMiddle, 48, 48)
    
    controls.queueGrid.Left:Set(function() return controls.queueBGCapMin.Right() - 14 end)
    controls.queueGrid.Right:Set(function() return controls.queueBGCapMax.Left() - 8 end)
    controls.queueGrid.Height:Set(48)
    LayoutHelpers.AtVerticalCenterIn(controls.queueGrid, controls.queueBGMiddle, -20)
end